package com.seeyon.apps.govdoc.option.util;

package ..deTemp.1746714899625;

import com.seeyon.apps.govdoc.helper.GovdocHelper;
import com.seeyon.apps.govdoc.manager.GovdocCommentManager;
import com.seeyon.apps.govdoc.manager.GovdocOpenManager;
import com.seeyon.apps.govdoc.manager.GovdocSignetManager;
import com.seeyon.apps.govdoc.option.manager.FormOptionExtendManager;
import com.seeyon.apps.govdoc.option.manager.FormOptionSortManager;
import com.seeyon.apps.govdoc.pishi.manager.GovdocPishiManager;
import com.seeyon.apps.govdoc.pishi.po.EdocLeaderPishiNo;
import com.seeyon.apps.govdoc.po.FormOptionExtend;
import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.ModuleType;
import com.seeyon.ctp.common.SystemEnvironment;
import com.seeyon.ctp.common.affair.manager.AffairManager;
import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ctp.common.constants.SystemProperties;
import com.seeyon.ctp.common.content.affair.constants.StateEnum;
import com.seeyon.ctp.common.content.affair.constants.SubStateEnum;
import com.seeyon.ctp.common.content.comment.Comment;
import com.seeyon.ctp.common.ctpenumnew.EnumNameEnum;
import com.seeyon.ctp.common.ctpenumnew.manager.EnumManager;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.file.model.CtpLocalFile;
import com.seeyon.ctp.common.filemanager.Constants;
import com.seeyon.ctp.common.filemanager.manager.AttachmentManager;
import com.seeyon.ctp.common.filemanager.manager.Util;
import com.seeyon.ctp.common.i18n.ResourceBundleUtil;
import com.seeyon.ctp.common.i18n.ResourceUtil;
import com.seeyon.ctp.common.log.CtpLogFactory;
import com.seeyon.ctp.common.po.affair.CtpAffair;
import com.seeyon.ctp.common.po.filemanager.Attachment;
import com.seeyon.ctp.form.api.FormApi4Cap3;
import com.seeyon.ctp.form.bean.FormBean;
import com.seeyon.ctp.form.bean.FormFieldBean;
import com.seeyon.ctp.form.util.FormUtil;
import com.seeyon.ctp.organization.bo.V3xOrgMember;
import com.seeyon.ctp.organization.manager.OrgManager;
import com.seeyon.ctp.util.Datetimes;
import com.seeyon.ctp.util.FlipInfo;
import com.seeyon.ctp.util.Strings;
import com.seeyon.ctp.util.json.JSONUtil;
import com.seeyon.v3x.edoc.constants.EdocOpinionDisplayEnum;
import com.seeyon.v3x.edoc.domain.EdocOpinion;
import com.seeyon.v3x.edoc.domain.EdocSummary;
import com.seeyon.v3x.edoc.util.Constants;
import com.seeyon.v3x.edoc.webmodel.EdocOpinionBO;
import com.seeyon.v3x.edoc.webmodel.EdocOpinionModel;
import com.seeyon.v3x.edoc.webmodel.FormOpinionConfig;
import com.seeyon.v3x.system.signet.domain.V3xHtmDocumentSignature;
import com.seeyon.v3x.system.signet.domain.V3xSignet;
import com.seeyon.v3x.system.signet.enums.V3xHtmSignatureEnum;
import com.seeyon.v3x.system.signet.manager.SignetManager;
import com.seeyon.v3x.system.signet.manager.V3xHtmDocumentSignatManager;
import com.thoughtworks.xstream.core.util.Base64Encoder;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Set;
import java.util.stream.Collectors;
import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;

public class EdocOptionDisplayUtil {
  private static final Log LOGGER = CtpLogFactory.getLog(com.seeyon.apps.govdoc.option.util.EdocOptionDisplayUtil.class);
  
  private static String getAttitude(Integer opinionType, int attitude) {
    String attitudeStr = null;
    String attitudeI18nLabel = "";
    if (attitude > 0)
      if (EdocOpinion.OpinionType.backOpinion.ordinal() == opinionType.intValue()) {
        attitudeI18nLabel = "stepBack.label";
      } else if (EdocOpinion.OpinionType.stopOpinion.ordinal() == opinionType.intValue()) {
        attitudeI18nLabel = "stepStop.label";
      } else if (EdocOpinion.OpinionType.repealOpinion.ordinal() == opinionType.intValue()) {
        attitudeI18nLabel = "edoc.repeal.2.label";
      } else {
        EnumManager enumManager = (EnumManager)AppContext.getBean("enumManagerNew");
        attitudeI18nLabel = enumManager.getEnumItemLabel(EnumNameEnum.collaboration_attitude, 
            Integer.toString(attitude));
      }  
    if (Strings.isNotBlank(attitudeI18nLabel)) {
      attitudeStr = ResourceUtil.getString(attitudeI18nLabel);
    } else if (attitude == Constants.EDOC_ATTITUDE_NULL) {
      attitudeStr = null;
    } 
    if (opinionType.intValue() == EdocOpinion.OpinionType.senderOpinion.ordinal())
      attitudeStr = null; 
    return attitudeStr;
  }
  
  private static String getOpinionUserName(Long userId, String proxyName, OrgManager orgManager, FormOpinionConfig displayConfig, EdocOpinion edocOpinion, boolean popUserInfo, boolean hasSign) {
    String doUserName = "";
    try {
      V3xOrgMember member = orgManager.getMemberById(userId);
      Long MainAccountId = member.getOrgAccountId();
      doUserName = member.getName();
      String postInfo = edocOpinion.getPostInfo();
      Long currentAccountId = null;
      if (Strings.isNotBlank(postInfo)) {
        String[] postInfos = postInfo.split("\\|");
        if (postInfos.length > 2) {
          String accountIdStringType = postInfos[0];
          currentAccountId = Long.valueOf(Long.parseLong(accountIdStringType));
        } 
      } 
      if (currentAccountId == null)
        currentAccountId = member.getOrgAccountId(); 
      if (edocOpinion.isBound() && EdocOpinionDisplayEnum.OpinionShowNameTypeEnum.SIGN
        
        .getValue().equals(displayConfig.getShowNameType())) {
        V3xHtmDocumentSignatManager v3xHtmDocumentSignatManager = (V3xHtmDocumentSignatManager)AppContext.getBean("v3xHtmDocumentSignatManager");
        FlipInfo flipInfo = new FlipInfo(-1, -1);
        flipInfo.setNeedTotal(false);
        List<V3xHtmDocumentSignature> signs = v3xHtmDocumentSignatManager.findBySummaryIdAndType(edocOpinion.getEdocId(), V3xHtmSignatureEnum.HTML_SIGNATURE_EDOC_FLOW_INSCRIBE.getKey(), flipInfo);
        List<V3xHtmDocumentSignature> signatureList = new ArrayList<>();
        if (Strings.isNotEmpty(signs))
          for (V3xHtmDocumentSignature sign : signs) {
            if (sign.getAffairId() != null && edocOpinion.getAffairId() == sign.getAffairId().longValue())
              signatureList.add(sign); 
          }  
        if (Strings.isNotEmpty(signatureList)) {
          GovdocSignetManager govdocSignetManager = (GovdocSignetManager)AppContext.getBean("govdocSignetManager");
          List<V3xSignet> signetList = govdocSignetManager.findSignetByMemberId(Long.valueOf(edocOpinion.getCreateUserId()));
          V3xSignet MainV3xSignet = null;
          V3xSignet v3xSignet = null;
          if (signetList != null && !signetList.isEmpty()) {
            Integer signType = Integer.valueOf(0);
            for (V3xSignet signTemp : signetList) {
              if (signType.equals(signTemp.getMarkType())) {
                if (currentAccountId == null) {
                  LOGGER.warn(String.format("未找到%s的单位id，随机取一个签名", new Object[] { userId }));
                  v3xSignet = signTemp;
                  break;
                } 
                if (signTemp.getOrgAccountId().longValue() == currentAccountId.longValue()) {
                  v3xSignet = signTemp;
                  continue;
                } 
                if (signTemp.getOrgAccountId().longValue() == MainAccountId.longValue())
                  MainV3xSignet = signTemp; 
              } 
            } 
          } 
          if (v3xSignet == null && MainV3xSignet != null)
            v3xSignet = MainV3xSignet; 
          if (v3xSignet != null) {
            String imgStr = "";
            if (FormUtil.isPhoneLogin() || FormUtil.isH5()) {
              if (v3xSignet.getMarkBodyByte() != null) {
                Base64Encoder encoder = new Base64Encoder();
                imgStr = encoder.encode(v3xSignet.getMarkBodyByte());
                imgStr = imgStr.replaceAll("\r\n", "").replace("\\", "");
                imgStr = imgStr.replaceAll("\n", "");
                String C_sPicDataFormat_Gif = "data:image/gif;base64,";
                String C_sPicDataFormat_Png = "data:image/png;base64,";
                String C_sPicDataFormat_Jpeg = "data:image/jpeg;base64,";
                if (imgStr.indexOf("iVBO") == 0) {
                  imgStr = C_sPicDataFormat_Png + imgStr;
                } else if (imgStr.indexOf("R0lG") == 0) {
                  imgStr = C_sPicDataFormat_Gif + imgStr;
                } else {
                  imgStr = C_sPicDataFormat_Jpeg + imgStr;
                } 
              } 
            } else {
              imgStr = SystemEnvironment.getContextPath() + "/edocController.do?method=showInscribeSignetPic&id=" + v3xSignet.getId();
            } 
            doUserName = "<IMG alt=\"" + Strings.toHTML(doUserName) + "\" style=\"pointer-events: none;vertical-align: text-bottom;max-width:100%;\" src=\"" + imgStr + "\" >";
          } else {
            LOGGER.warn(String.format("未找到%s的签名！", new Object[] { userId }));
          } 
        } 
      } 
      User user = AppContext.getCurrentUser();
      if (member.getIsAdmin().booleanValue()) {
        doUserName = "<span> " + doUserName + "</span>";
      } else if (popUserInfo && "pc".equals(user.getUserAgentFrom())) {
        doUserName = "<span style='color:#2490f8; display:inline-block;cursor:pointer;' onclick='javascript:showV3XMemberCard(\"" + userId + "\",parent.window)'>" + doUserName + "</span>";
      } 
      if (FormUtil.isPhoneLogin() && 
        displayConfig.isHideInscriber() && hasSign)
        doUserName = ""; 
      if (!Strings.isBlank(proxyName) && !proxyName.equals(member.getName()))
        doUserName = doUserName + ResourceBundleUtil.getString("com.seeyon.v3x.edoc.resources.i18n.EdocResource", "edoc.opinion.proxy", new Object[] { proxyName }); 
    } catch (Exception e) {
      LOGGER.error("取公文单显示的时候的人名 抛出异常", e);
    } 
    return doUserName;
  }
  
  public static byte[] hex2byte(String str) {
    if (str == null)
      return null; 
    str = str.trim();
    int len = str.length();
    if (len == 0 || len % 2 == 1)
      return null; 
    byte[] b = new byte[len / 2];
    try {
      for (int i = 0; i < str.length(); i += 2)
        b[i / 2] = (byte)Integer.decode("0X" + str.substring(i, i + 2)).intValue(); 
      return b;
    } catch (Exception e) {
      LOGGER.error("", e);
      return null;
    } 
  }
  
  public static Map<String, Object> convertOpinionToString(Map<String, EdocOpinionModel> map, FormOpinionConfig displayConfig, CtpAffair currentAffair, boolean isFromPending, List<V3xHtmDocumentSignature> signatuers, List<Comment> commentList) throws BusinessException {
    return convertOpinionToString(map, displayConfig, signatuers, commentList);
  }
  
  public static Map<String, Object> convertOpinionToString(Map<String, EdocOpinionModel> map, FormOpinionConfig displayConfig, List<V3xHtmDocumentSignature> signatuers, List<Comment> commentList) throws BusinessException {
    GovdocOpenManager govdocOpenManager = (GovdocOpenManager)AppContext.getBean("govdocOpenManager");
    AttachmentManager attachmentManager = (AttachmentManager)AppContext.getBean("attachmentManager");
    GovdocPishiManager govdocPishiManager = (GovdocPishiManager)AppContext.getBean("govdocPishiManager");
    boolean hasEdit = govdocOpenManager.hasEditAuth(Long.valueOf(AppContext.currentUserId()), Long.valueOf(AppContext.currentAccountId()));
    boolean synCommentInForm = govdocOpenManager.isSynCommentInForm();
    Map<Long, StringBuilder> senderAttMap = new HashMap<>();
    List<EdocOpinion> senderOpinions = new ArrayList<>();
    List<Attachment> commentAttachments = new ArrayList<>();
    int backOpinonType = displayConfig.getBackOpinionType();
    Map<Long, List<Comment>> commentMap = new HashMap<>();
    Map<Long, Comment> affairIdToCommentMap = new HashMap<>();
    Map<Long, EdocLeaderPishiNo> affairIdToPishiNoMap = new HashMap<>();
    if (Strings.isNotEmpty(commentList)) {
      affairIdToPishiNoMap = govdocPishiManager.getPishiNoMapByAffairId((Collection)commentList.stream().map(Comment::getAffairId).collect(Collectors.toSet()));
      for (Comment comment : commentList) {
        List<Comment> comments = new ArrayList<>();
        if (Strings.isNotEmpty(commentMap.get(comment.getAffairId())))
          comments = commentMap.get(comment.getAffairId()); 
        if (backOpinonType == 1 && "common.toolbar.stepBack.label".equals(comment.getExtAtt3()))
          continue; 
        if (!"common.save.and.pause.flow".equals(comment.getExtAtt3()) && comment.getCtype() != null && comment.getCtype().intValue() == Comment.CommentType.comment.getKey()) {
          if (affairIdToCommentMap.get(comment.getAffairId()) != null)
            LOGGER.error("获取comment错误。affairId 相同存在两条非暂存代办的评论！commentId= " + comment.getId()); 
          affairIdToCommentMap.put(comment.getAffairId(), comment);
        } 
        comments.add(comment);
        commentMap.put(comment.getAffairId(), comments);
      } 
    } 
    Map<String, Object> jsMap = new HashMap<>();
    String fileUrlStr = "";
    OrgManager orgManager = (OrgManager)AppContext.getBean("orgManager");
    Iterator<String> it;
    for (it = map.keySet().iterator(); it.hasNext(); ) {
      String element = it.next();
      EdocOpinionModel model = map.get(element);
      List<EdocOpinion> opinions = model.getOpinions();
      boolean showZcdb = !FormOpinionConfig.checkBoolean(displayConfig.getZcdbOptionType());
      for (EdocOpinion opinion : opinions) {
        if ((opinion.getOpinionType().intValue() == EdocOpinion.OpinionType.provisionalOpinoin.ordinal() && !showZcdb) || opinion
          .getOpinionType().intValue() == EdocOpinion.OpinionType.draftOpinion.ordinal())
          continue; 
        boolean showEditAndDelButton = (!synCommentInForm && hasEdit && opinion.getOpinionType().intValue() != EdocOpinion.OpinionType.provisionalOpinoin.ordinal() && !FormUtil.isPhoneLogin());
        StringBuilder sb = new StringBuilder();
        String value = (String)jsMap.get(element);
        if (value != null)
          sb.append(value); 
        boolean hasSignature = false;
        if (signatuers != null && signatuers.size() > 0)
          for (V3xHtmDocumentSignature signature : signatuers) {
            if (signature != null && 
              null != signature.getAffairId() && signature.getAffairId().equals(Long.valueOf(opinion.getAffairId())))
              hasSignature = true; 
          }  
        String attitude = "";
        String tempAttitude = "";
        switch (opinion.getAttribute()) {
          case 1:
            tempAttitude = "haveRead";
            break;
          case 2:
            tempAttitude = "agree";
            break;
          case 3:
            tempAttitude = "disagree";
            break;
        } 
        Comment comment = null;
        List<Comment> comments = commentMap.get(Long.valueOf(opinion.getAffairId()));
        if (Strings.isNotEmpty(comments))
          if (comments.size() == 1) {
            comment = comments.get(0);
          } else {
            for (Comment tempComment : comments) {
              if (tempComment.getCreateDate().equals(opinion.getCreateTime())) {
                comment = tempComment;
                break;
              } 
            } 
            if (comment == null) {
              Date beforeTwoSecond = Datetimes.addSecond(opinion.getCreateTime(), -3);
              Date afterTwoSecond = Datetimes.addSecond(opinion.getCreateTime(), 3);
              for (Comment tempComment : comments) {
                if (Datetimes.between(tempComment.getCreateDate(), beforeTwoSecond, afterTwoSecond, false)) {
                  comment = tempComment;
                  break;
                } 
              } 
            } 
            if (comment == null)
              comment = comments.get(0); 
          }  
        if (comment != null) {
          if (tempAttitude.equals((comment.getExtAtt4() == null) ? "" : comment.getExtAtt4()))
            attitude = comment.getExtAtt1I18n(); 
          if (Strings.isNotBlank(comment.getExtAtt1()))
            attitude = comment.getExtAtt1I18n(); 
          if (Objects.nonNull(comment.getCreateDate()))
            opinion.setCreateTime(new Timestamp(comment.getCreateDate().getTime())); 
        } 
        if (Strings.isBlank(attitude) && !Strings.isBlank(tempAttitude))
          attitude = ResourceUtil.getString("collaboration.dealAttitude." + tempAttitude); 
        sb.append(displayOpinionContent(displayConfig, opinion, hasSignature, true, attitude));
        List<Attachment> tempAtts = null;
        if (null != opinion.getPolicy() && opinion.getPolicy().equals("feedback")) {
          Long subOpinionId = opinion.getSubOpinionId();
          if (subOpinionId != null)
            tempAtts = GovdocHelper.getOpinionAttachmentsNotRelationDoc(opinion.getSubEdocId().longValue(), subOpinionId.longValue()); 
        } else {
          tempAtts = opinion.getOpinionAttachments();
        } 
        if (tempAtts != null && displayConfig.isShowAtt()) {
          StringBuilder attSb = new StringBuilder();
          sb.append("<br/>");
          attSb.append("<div style='clear:both;'>");
          for (Attachment att : tempAtts) {
            fileUrlStr = fileUrlStr + att.getFileUrl() + ",";
            String s = "";
            String attJson = JSONUtil.toJSONString(att);
            Map<String, Object> maps = (Map<String, Object>)JSONUtil.parseJSONString(attJson);
            maps.put("command", "131");
            maps.put("name", att.getFilename());
            attJson = JSONUtil.toJSONString(maps);
            String attType = (maps.get("icon") != null) ? maps.get("icon").toString() : "";
            String miniType = "";
            if (!"".equals(attType) && attType.contains("."))
              miniType = attType.split("\\.")[0]; 
            if (FormUtil.isPhoneLogin() || FormUtil.isH5()) {
              String iconClass = "";
              if (Strings.isNotBlank(miniType))
                iconClass = getIconClass(miniType); 
              String icon = "<i class='attachment-icon " + iconClass + "'></i>";
              s = "<div style='display:block'>" + icon + "<a class='document-content allow-click-attachment' style='text-decoration:underline;margin-left:10px;font-size:12px;color:#005599' see-att-data = '" + attJson + "'>" + att.getFilename() + "</a></div>";
            } else {
              String imageStr = "<span style=\"word-wrap:break-word; word-break:break-all;position:relative;top:-1px;\" class=\"ico16 " + miniType + "_16 margin_r_5\"></span>";
              String str = Util.AttachmentToHtmlWithShowAllFileName(att, true, false);
              if (StringUtils.isNotEmpty(att.getSecretLevelName())) {
                String old = Strings.toHTML(att.getFilename()) + "(";
                StringBuffer newT = new StringBuffer();
                if (att.getType().intValue() == Constants.ATTACHMENT_TYPE.DOCUMENT.ordinal()) {
                  old = ">" + Strings.toHTML(att.getFilename()) + "<";
                  newT.append("><span style=\"color:#FF4141\">[" + att.getSecretLevelName() + "]</span>").append(Strings.toHTML(att.getFilename())).append("<").toString();
                } else {
                  newT.append("<span style=\"color:#FF4141\">[" + att.getSecretLevelName() + "]</span>").append(Strings.toHTML(att.getFilename())).append("(").toString();
                } 
                str = str.replace(old, newT.toString());
              } 
              int imgBegin = str.indexOf("<img");
              s = str.substring(0, imgBegin) + imageStr + str.substring(str.indexOf("<", imgBegin + 4), str.length());
            } 
            sb.append(s);
            attSb.append(s);
          } 
          attSb.append("</div>");
          if ("senderOpinion".equals(element))
            senderAttMap.put(opinion.getId(), attSb); 
        } 
        if (showEditAndDelButton) {
          Comment opinionToComment = affairIdToCommentMap.get(Long.valueOf(opinion.getAffairId()));
          EdocLeaderPishiNo edocLeaderPishiNo = affairIdToPishiNoMap.get(Long.valueOf(opinion.getAffairId()));
          if (opinionToComment != null) {
            sb.append(displayEditAndDelButton(opinionToComment.getId(), opinion, edocLeaderPishiNo));
            sb.append("<br/>");
          } 
        } 
        if ("senderOpinion".equals(element)) {
          senderOpinions.add(opinion);
          continue;
        } 
        if (tempAtts == null || !displayConfig.isShowAtt())
          sb.append("<br/>"); 
        jsMap.put(element, sb.toString());
      } 
    } 
    if (Strings.isNotBlank(fileUrlStr) && fileUrlStr.length() > 1)
      fileUrlStr = fileUrlStr.substring(0, fileUrlStr.length() - 1); 
    for (it = affairIdToCommentMap.values().iterator(); it.hasNext(); ) {
      Comment comment = (Comment)it.next();
      List<Attachment> commentAtts = attachmentManager.getByReference(comment.getModuleId(), comment.getId());
      if (CollectionUtils.isNotEmpty(commentAtts))
        commentAttachments.addAll(commentAtts); 
    } 
    AppContext.putRequestContext("fileUrlStr", fileUrlStr);
    jsMap.put("senderOpinionAttStr", senderAttMap);
    jsMap.put("senderOpinionList", senderOpinions);
    jsMap.put("commentAttachments", commentAttachments);
    return jsMap;
  }
  
  private static String displayEditAndDelButton(Long commentId, EdocOpinion opinion, EdocLeaderPishiNo edocLeaderPishiNo) {
    String edocLeaderPishiStr = "";
    if (edocLeaderPishiNo != null) {
      StringBuilder sb = new StringBuilder();
      String pishiName = edocLeaderPishiNo.getPishiName();
      Integer pishiNo = edocLeaderPishiNo.getPishiNo();
      String pishiYear = edocLeaderPishiNo.getPishiYear();
      Date proxyDate = edocLeaderPishiNo.getProxyDate();
      String proxyDateShow = Datetimes.formatDate(edocLeaderPishiNo.getProxyDate());
      sb.append("hasPishi=\"true\"");
      sb.append("pishiName=\"" + pishiName + "\"");
      sb.append("pishiNo=\"" + pishiNo + "\"");
      sb.append("pishiYear=\"" + pishiYear + "\"");
      sb.append("proxyDate=\"" + proxyDate + "\"");
      sb.append("proxyDateShow=\"" + proxyDateShow + "\"");
      edocLeaderPishiStr = Strings.toText(sb.toString());
    } 
    String content = Strings.toHTML(opinion.getContent());
    String opinionId = opinion.getId().toString();
    Long affairId = Long.valueOf(opinion.getAffairId());
    return "<a " + edocLeaderPishiStr + " class=\"formPrintHide\"  onclick=\"openEditWindow(this)\" affairId=\"" + affairId + "\" content=\"" + content + "\" commentId=\"" + commentId + "\"  opinionId=\"" + opinionId + "\"  >" + ResourceUtil.getString("common.operate.edit") + "</a>&nbsp&nbsp<a   class=\"formPrintHide\"  onclick=\"delComment('" + commentId + "')\" >" + 
      ResourceUtil.getString("common.toolbar.delete.label") + "</a>";
  }
  
  private static String replaceStr2Blank(String src, String defualt) {
    StringBuilder ret = new StringBuilder();
    if (Strings.isBlank(src) && defualt != null) {
      ret.append(defualt);
    } else {
      for (int i = 0; i < src.length(); i++) {
        char c = src.charAt(i);
        if (c > '\000' && c < 'ÿ') {
          ret.append(ResourceUtil.getString("govdoc.space"));
        } else {
          ret.append(ResourceUtil.getString("govdoc.space.quan"));
        } 
      } 
    } 
    return ret.toString();
  }
  
  private static String displayOpinionContent(FormOpinionConfig displayConfig, EdocOpinion opinion, boolean hasSignature, boolean popUserInfo, String attitude) {
    OrgManager orgManager = (OrgManager)AppContext.getBean("orgManager");
    StringBuilder sb = new StringBuilder();
    String attribute = attitude;
    String userName = getOpinionUserName(Long.valueOf(opinion.getCreateUserId()), opinion.getProxyName(), orgManager, displayConfig, opinion, popUserInfo, hasSignature);
    String content = opinion.getContent();
    String divId = String.valueOf(opinion.getAffairId());
    if (opinion.getOpinionType().intValue() == EdocOpinion.OpinionType.provisionalOpinoin.ordinal())
      divId = divId + "_zc"; 
    sb.append("<div id='" + divId + "' class='edocOpinion' style='clear:both;'>");
    sb.append("</div>");
    boolean newLine = displayConfig.isInscriberNewLine();
    if (newLine)
      sb.append("<span>"); 
    if (!FormOpinionConfig.checkBoolean(displayConfig.getAttitude()))
      attribute = ""; 
    if (!FormOpinionConfig.checkBoolean(displayConfig.getComment()))
      content = ""; 
    String blankString = "";
    String attrStr = null;
    if (Strings.isNotBlank(attribute) && attribute != null && null != opinion.getPolicy() && !opinion.getPolicy().equals("report")) {
      attrStr = "【" + attribute + "】";
      sb.append(attrStr);
    } 
    sb.append(Strings.toHTML(content));
    if (newLine)
      sb.append("</span><br/>"); 
    boolean alignRight = FormOpinionConfig.checkBoolean(displayConfig.getInscriberRight());
    if (newLine) {
      if (alignRight) {
        sb.append("<span style='text-align: right;width: 100%;display: inline-block; font-size: inherit;font-weight: inherit;font-style: inherit;'>");
      } else {
        sb.append("<span>");
        sb.append(blankString);
      } 
    } else if (Strings.isNotBlank(content)) {
      if (displayConfig.isShowDept() || displayConfig.isShowUnit())
        sb.append("&ensp;&ensp;"); 
    } 
    boolean isDisplay = true;
    if (displayConfig.isHideInscriber()) {
      AffairManager affairManager = (AffairManager)AppContext.getBean("affairManager");
      CtpAffair affair = null;
      try {
        affair = affairManager.get(Long.valueOf(opinion.getAffairId()));
        if (affair != null && affair.getSubState().intValue() == SubStateEnum.col_done_stepStop.key())
          isDisplay = false; 
      } catch (BusinessException e) {
        LOGGER.error("获取affair错误", (Throwable)e);
      } 
    } 
    if (displayConfig.isShowUnit() && (!displayConfig.isHideInscriber() || !hasSignature) && isDisplay)
      if (userName.indexOf("IMG") != -1 || newLine) {
        sb.append(opinion.getAccountName());
      } else {
        sb.append("&ensp;").append(opinion.getAccountName());
      }  
    if (displayConfig.isShowDept() && (!displayConfig.isHideInscriber() || !hasSignature) && isDisplay)
      if ((userName.indexOf("IMG") != -1 || newLine) && !displayConfig.isShowUnit()) {
        sb.append(opinion.getDepartmentName());
      } else {
        sb.append("&ensp;").append(opinion.getDepartmentName());
      }  
    if (displayConfig.isShowName() && (!displayConfig.isHideInscriber() || !hasSignature) && isDisplay)
      sb.append("&ensp;").append(userName); 
    String dateStr = "";
    if (EdocOpinionDisplayEnum.OpinionDateFormatSetEnum.DATETIME.getValue().equals(displayConfig.getShowDateType())) {
      if (EdocOpinionDisplayEnum.OpinionDateModelSetEnum.FULL.getValue().equals(displayConfig.getShowDateModel())) {
        Date current = opinion.getCreateTime();
        dateStr = Datetimes.format(current, ResourceUtil.getString("govdoc.date.format"));
      } else {
        dateStr = Datetimes.formatDatetimeWithoutSecond(opinion.getCreateTime());
      } 
    } else if (EdocOpinionDisplayEnum.OpinionDateFormatSetEnum.DATE.getValue().equals(displayConfig.getShowDateType())) {
      if (EdocOpinionDisplayEnum.OpinionDateModelSetEnum.FULL.getValue().equals(displayConfig.getShowDateModel())) {
        Date current = opinion.getCreateTime();
        dateStr = Datetimes.format(current, ResourceUtil.getString("govdoc.date.format1"));
      } else {
        dateStr = Datetimes.formatDate(opinion.getCreateTime());
      } 
    } else if (EdocOpinionDisplayEnum.OpinionDateFormatSetEnum.TIME.getValue().equals(displayConfig.getShowDateType())) {
      if (EdocOpinionDisplayEnum.OpinionDateModelSetEnum.FULL.getValue().equals(displayConfig.getShowDateModel())) {
        Date current = opinion.getCreateTime();
        dateStr = Datetimes.format(current, ResourceUtil.getString("govdoc.date.format3"));
      } else {
        dateStr = Datetimes.format(opinion.getCreateTime(), " HH:mm");
      } 
    } 
    boolean dateNewLine = false;
    if (Strings.isNotBlank(dateStr)) {
      dateNewLine = FormOpinionConfig.checkBoolean(displayConfig.getDateNewLine());
      if (dateNewLine) {
        String styleText = "";
        if (alignRight)
          styleText = "text-align: right;width: 100%;display: inline-block;font-size: inherit;font-weight: inherit;font-style: inherit;"; 
        if (newLine) {
          sb.append("</span>");
          sb.append("<br/>");
          sb.append("<span style='color:black;display:block;" + styleText + "'>");
          if (!alignRight)
            sb.append(""); 
          sb.append(dateStr);
        } else {
          sb.append("<br/>");
          sb.append("<span style='display:block;" + styleText + "'>");
          sb.append(dateStr);
          sb.append("</span>");
        } 
      } else {
        sb.append("&ensp;").append(dateStr);
      } 
    } 
    if (newLine)
      if (alignRight) {
        sb.append("</span>");
      } else {
        sb.append("</span>");
      }  
    if (dateNewLine)
      sb.append("<br/>"); 
    return sb.toString().replaceAll("&nbsp;", "&ensp;");
  }
  
  private static V3xOrgMember getMember(Long id, OrgManager orgManager) {
    V3xOrgMember member = new V3xOrgMember();
    try {
      member = orgManager.getMemberById(id);
    } catch (BusinessException e) {
      LOGGER.error("", (Throwable)e);
    } 
    return member;
  }
  
  public static String optionToJs(Map<String, Object> hs) {
    String key = "";
    StringBuilder opinionsJs = new StringBuilder();
    opinionsJs.append("var opinions=[");
    Iterator<String> it = hs.keySet().iterator();
    boolean isFirst = true;
    String szTemp = null;
    while (it.hasNext()) {
      key = it.next();
      if ("senderOpinionList".equals(key) || "senderOpinionAttStr".equals(key) || "commentAttachments".equals(key))
        continue; 
      if (isFirst) {
        isFirst = false;
      } else {
        opinionsJs.append(",");
      } 
      szTemp = hs.get(key).toString();
      szTemp = Strings.escapeJavascript(szTemp);
      opinionsJs.append("[\"").append(key).append("\",\"").append(szTemp).append("\"]");
    } 
    opinionsJs.append("];");
    opinionsJs.append("\r\n");
    String sendOpinionStr = "";
    Object sendOpinionObj = hs.get("senderOpinionList");
    Object opinionsAttachmentList = hs.get("commentAttachments");
    if (opinionsAttachmentList != null)
      opinionsJs.append("var opinionsAttachmentList=" + JSONUtil.toJSONString(opinionsAttachmentList) + ";"); 
    if (sendOpinionObj != null)
      sendOpinionStr = sendOpinionObj.toString(); 
    if ("[]".equals(sendOpinionStr))
      sendOpinionStr = ""; 
    opinionsJs.append("var sendOpinionStr=\"" + sendOpinionStr + "\";");
    opinionsJs.append("var edocDetailURL=\"" + SystemEnvironment.getContextPath() + "/edocController.do\";");
    return opinionsJs.toString();
  }
  
  public static String getEdocOpinionPolicy(Map<String, EdocOpinionModel> map) {
    Set<Map.Entry<String, EdocOpinionModel>> set = null;
    String policy = null;
    if (map != null && !map.isEmpty()) {
      set = map.entrySet();
      if (set != null && !set.isEmpty()) {
        Iterator<Map.Entry<String, EdocOpinionModel>> it = set.iterator();
        while (it.hasNext()) {
          Map.Entry entry = it.next();
          if (entry != null)
            policy = entry.getKey().toString(); 
        } 
      } 
    } 
    return policy;
  }
  
  public static List<EdocOpinionBO> sortEdocOpinion(List<EdocOpinion> opinions) {
    List<EdocOpinionBO> opinionBOs = new ArrayList<>();
    EdocOpinionBO edocOpinionBO = null;
    try {
      if (opinions != null)
        for (int i = 0; i < opinions.size(); i++) {
          edocOpinionBO = new EdocOpinionBO();
          BeanUtils.copyProperties(edocOpinionBO, opinions.get(i));
          opinionBOs.add(edocOpinionBO);
        }  
    } catch (Exception exception) {}
    return opinionBOs;
  }
  
  public static String getAffairReturnState(Map<String, EdocOpinionModel> map, String policy, CtpAffair currentAffair) throws BusinessException {
    List<EdocOpinion> opinions = null;
    EdocOpinionModel edocOpinionModel = null;
    if (map != null)
      edocOpinionModel = map.get(policy); 
    if (edocOpinionModel != null)
      opinions = edocOpinionModel.getOpinions(); 
    return getAffairReturnState(opinions, currentAffair);
  }
  
  public static String getAffairReturnState(List<EdocOpinion> opinions, CtpAffair currentAffair) throws BusinessException {
    List<EdocOpinionBO> opinionBOs = sortEdocOpinion(opinions);
    AffairManager affairManager = (AffairManager)AppContext.getBean("affairManager");
    String affairState = "";
    if (opinionBOs != null) {
      EdocOpinionBO edocOpinion = null;
      CtpAffair affair1 = null;
      CtpAffair affair = null;
      int count = opinionBOs.size();
      long currentUserId = AppContext.getCurrentUser().getId().longValue();
      for (int i = count - 1; i >= 0; i--) {
        edocOpinion = opinionBOs.get(i);
        affair1 = affairManager.get(Long.valueOf(edocOpinion.getAffairId()));
        if (affair1 != null) {
          boolean isCurrentAffair = (affair1 != null && affair1.getActivityId() != null && currentAffair.getActivityId() != null && affair1.getActivityId().equals(currentAffair.getActivityId()) && affair1.getMemberId().longValue() == currentUserId);
          boolean isCurrentAffairState = (affair1.getState().intValue() == StateEnum.col_pending.key() && (affair1.getSubState().intValue() == SubStateEnum.col_pending_ZCDB.key() || affair1.getSubState().intValue() == SubStateEnum.col_pending_read.key()));
          if (isCurrentAffair && !isCurrentAffairState) {
            affair = affair1;
            break;
          } 
        } 
      } 
      if (affair != null)
        affairState = String.valueOf(affair.getState()); 
    } 
    return affairState;
  }
  
  private static String subLargerGuanlanWendang(String str) {
    int begin = str.indexOf("style='font-size:12px'>");
    int end = str.indexOf("</a>");
    if (begin != -1 || end != -1) {
      String wname = str.substring(begin, end).replace("style='font-size:12px'>", "");
      StringBuilder sb = new StringBuilder();
      if (wname.length() < 30)
        return str; 
      sb.append(str.substring(0, begin));
      sb.append("style='font-size:12px'>");
      wname = wname.replace("&nbsp;", " ");
      if (wname.length() > 30)
        wname = wname.substring(0, 30); 
      sb.append(wname);
      sb.append("......");
      sb.append(str.substring(end));
      return sb.toString();
    } 
    return str;
  }
  
  private static String getOpinionImgUserNameForGZZB(Long userId, String proxyName, OrgManager orgManager) {
    String doUserName = "";
    try {
      V3xOrgMember member = orgManager.getMemberById(userId);
      doUserName = member.getName();
      if (member.getIsAdmin().booleanValue()) {
        doUserName = "";
      } else {
        SignetManager signetManager = (SignetManager)AppContext.getBean("signetManager");
        List<V3xSignet> signets = signetManager.findSignetByMemberId(userId);
        V3xSignet ssi = null;
        if (signets != null && signets.size() > 0)
          for (int i = 0; i < signets.size(); i++) {
            if (((V3xSignet)signets.get(i)).getMarkType().equals(Integer.valueOf(0))) {
              ssi = signets.get(i);
              break;
            } 
          }  
        String namePath = SystemEnvironment.getContextPath() + "/apps_res/edoc/images/signets/";
        if (ssi != null) {
          byte[] b = ssi.getMarkBodyByte();
          String path = SystemProperties.getInstance().getProperty("A8.base.folder") + "/";
          path = path + "../ApacheJetspeed/webapps";
          path = path + namePath;
          CtpLocalFile file = new CtpLocalFile(path);
          if (!file.exists())
            file.mkdirs(); 
          path = path + userId + ssi.getImgType();
          writeFile(path, b);
          String spath = namePath + userId + ssi.getImgType() + "?r=" + System.currentTimeMillis();
          doUserName = "<img name='signimg' src=" + spath + " class='color_blue'  onclick='javascript:showV3XMemberCard(\"" + userId + "\")'></img>";
        } else {
          doUserName = "<span class='color_blue' onclick='javascript:showV3XMemberCard(\"" + userId + "\")'>" + doUserName + "</span>";
        } 
      } 
      if (!Strings.isBlank(proxyName))
        doUserName = doUserName + ResourceBundleUtil.getString("com.seeyon.v3x.edoc.resources.i18n.EdocResource", "edoc.opinion.proxy", new Object[] { proxyName }); 
    } catch (Exception e) {
      LOGGER.error(e.getMessage(), e);
    } 
    doUserName = "<br>&nbsp;&nbsp;&nbsp;&nbsp;" + doUserName;
    return doUserName;
  }
  
  private static String getIconClass(String type) {
    if ("txt".equals(type))
      return "see-icon-v5-form-ic-txt-fill"; 
    if ("jpg".equals(type) || "png".equals(type) || "icon".equals(type) || "gif".equals(type))
      return "see-icon-v5-form-ic-image-fill"; 
    if ("doc".equals(type) || "docx".equals(type))
      return "see-icon-v5-form-ic-doc-fill"; 
    if ("xls".equals(type) || "xlsx".equals(type))
      return "see-icon-v5-form-ic-xls-fill"; 
    if ("ppt".equals(type) || "pptx".equals(type))
      return "see-icon-v5-form-ic-ppt-fill"; 
    if ("wps".equals(type))
      return "see-icon-v5-form-ic-wps-fill"; 
    if ("vsd".equals(type))
      return "see-icon-v5-form-ic-vsd-fill"; 
    if ("pdf".equals(type))
      return "see-icon-v5-form-ic-pdf-fill"; 
    if ("et".equals(type))
      return "see-icon-v5-form-ic-et-fill"; 
    if ("htm".equals(type) || "html".equals(type) || "sht".equals(type) || "shtm".equals(type) || "shtml"
      .equals(type) || "asp".equals(type) || "aspx".equals(type) || "php".equals(type) || "jsp"
      .equals(type))
      return "see-icon-v5-form-ic-html-fill"; 
    if ("mp3".equals(type))
      return "see-icon-v5-form-ic-mp3-fill"; 
    if ("avi".equals(type) || "mp4".equals(type) || "wmv".equals(type) || "rm".equals(type) || "rmvb"
      .equals(type) || "mpg".equals(type) || "mkv".equals(type) || "flv".equals(type))
      return "see-icon-v5-form-ic-mp4-fill"; 
    if ("wma".equals(type) || "wav".equals(type) || "amr".equals(type) || "ACT".equals(type) || "ava"
      .equals(type))
      return "see-icon-v5-form-ic-voice-fill"; 
    if ("zip".equals(type) || "rar".equals(type) || "jar".equals(type) || "tar".equals(type) || "7z"
      .equals(type))
      return "see-icon-v5-form-ic-zip-fill"; 
    if ("collaboration".equals(type))
      return "see-icon-v5-form-ic-col-fill"; 
    if ("edoc".equals(type))
      return "see-icon-v5-form-ic-offdoc-fill"; 
    if ("km".equals(type))
      return "see-icon-v5-form-relation-doc"; 
    if ("exe".equals(type))
      return "cmp-icon-document exe"; 
    if ("ofd".equals(type))
      return "cmp-icon-document ofd"; 
    return "see-icon-v5-form-ic-unknown-fill";
  }
  
  public static void writeFile(String url, byte[] b) {
    CtpLocalFile file = new CtpLocalFile(url);
    BufferedOutputStream stream = null;
    FileOutputStream fstream = null;
    try {
      if (file.exists())
        file.delete(); 
      file.createNewFile();
      fstream = new FileOutputStream((File)file);
      stream = new BufferedOutputStream(fstream);
      stream.write(b);
    } catch (IOException e) {
      LOGGER.error(e);
    } finally {
      try {
        if (stream != null)
          stream.close(); 
      } catch (IOException e) {
        LOGGER.error(e);
      } 
      try {
        if (fstream != null)
          fstream.close(); 
      } catch (IOException e) {
        LOGGER.error(e);
      } 
    } 
  }
  
  public static String getOpinionUserNameForM3(V3xOrgMember member, FormOpinionConfig displayConfig, EdocOpinion edocOpinion, boolean hasHandWriteSignature, List<V3xHtmDocumentSignature> edocOpinionSigns, String proxyName) {
    String doUserName = "";
    try {
      doUserName = member.getName();
      String postInfo = edocOpinion.getPostInfo();
      Long accountId = null;
      if (Strings.isNotBlank(postInfo)) {
        String[] postInfos = postInfo.split("\\|");
        if (postInfos.length > 2) {
          String accountIdStringType = postInfos[0];
          accountId = Long.valueOf(Long.parseLong(accountIdStringType));
        } 
      } 
      if (accountId == null)
        accountId = member.getOrgAccountId(); 
      if (edocOpinion.isBound() && EdocOpinionDisplayEnum.OpinionShowNameTypeEnum.SIGN
        
        .getValue().equals(displayConfig.getShowNameType())) {
        List<V3xHtmDocumentSignature> signatureList = new ArrayList<>();
        if (Strings.isNotEmpty(edocOpinionSigns))
          for (V3xHtmDocumentSignature sign : edocOpinionSigns) {
            if (sign.getAffairId() != null && Strings.equals(Long.valueOf(edocOpinion.getAffairId()), sign.getAffairId()))
              signatureList.add(sign); 
          }  
        if (Strings.isNotEmpty(signatureList)) {
          GovdocSignetManager govdocSignetManager = (GovdocSignetManager)AppContext.getBean("govdocSignetManager");
          List<V3xSignet> signetList = govdocSignetManager.findSignetByMemberId(Long.valueOf(edocOpinion.getCreateUserId()));
          V3xSignet v3xSignet = null;
          if (signetList != null && !signetList.isEmpty()) {
            Integer signType = new Integer(0);
            for (V3xSignet signTemp : signetList) {
              if (signType.equals(signTemp.getMarkType())) {
                if (accountId == null) {
                  v3xSignet = signTemp;
                  break;
                } 
                if (signTemp.getOrgAccountId().longValue() == accountId.longValue()) {
                  v3xSignet = signTemp;
                  break;
                } 
              } 
            } 
          } 
          if (v3xSignet != null)
            doUserName = "id=" + v3xSignet.getId(); 
        } 
      } 
      if (member.getIsAdmin().booleanValue())
        doUserName = ""; 
      if (displayConfig.isHideInscriber() && hasHandWriteSignature)
        doUserName = ""; 
      if (!Strings.isBlank(proxyName) && !doUserName.startsWith("id="))
        doUserName = doUserName + ResourceBundleUtil.getString("com.seeyon.v3x.edoc.resources.i18n.EdocResource", "edoc.opinion.proxy", new Object[] { proxyName }); 
    } catch (Exception e) {
      LOGGER.error("取公文单显示的时候的人名 抛出异常", e);
    } 
    return doUserName;
  }
  
  public static List<Object> getGovdocOpinionsForM3TaoHong(EdocSummary summary) throws BusinessException {
    FormApi4Cap3 formApi4Cap3 = (FormApi4Cap3)AppContext.getBean("formApi4Cap3");
    FormOptionExtendManager formOptionExtendManager = (FormOptionExtendManager)AppContext.getBean("formOptionExtendManager");
    FormOptionSortManager formOptionSortManager = (FormOptionSortManager)AppContext.getBean("formOptionSortManager");
    V3xHtmDocumentSignatManager v3xHtmDocumentSignatManager = (V3xHtmDocumentSignatManager)AppContext.getBean("v3xHtmDocumentSignatManager");
    GovdocCommentManager govdocCommentManager = (GovdocCommentManager)AppContext.getBean("govdocCommentManager");
    OrgManager orgManager = (OrgManager)AppContext.getBean("orgManager");
    AffairManager affairManager = (AffairManager)AppContext.getBean("affairManager");
    FormOpinionConfig displayConfig = getFormOpinionConfig(summary, formOptionExtendManager);
    Map<String, EdocOpinionModel> filedNameMapOpinions = formOptionSortManager.getGovdocOpinion(summary.getFormAppid().longValue(), summary, displayConfig);
    List<V3xHtmDocumentSignature> handWrites = v3xHtmDocumentSignatManager.findBySummaryIdAndType(summary.getId(), V3xHtmSignatureEnum.HTML_SIGNATURE_DOCUMENT
        .getKey());
    Map<Long, V3xHtmDocumentSignature> affairIdMapHandWriteSign = null;
    if (Strings.isNotEmpty(handWrites))
      affairIdMapHandWriteSign = (Map<Long, V3xHtmDocumentSignature>)handWrites.stream().collect(Collectors.toMap(V3xHtmDocumentSignature::getAffairId, signature -> signature, (a, b) -> b)); 
    List<V3xHtmDocumentSignature> edocOpinionSigns = v3xHtmDocumentSignatManager.findBySummaryIdAndType(summary.getId(), V3xHtmSignatureEnum.HTML_SIGNATURE_EDOC_FLOW_INSCRIBE
        .getKey());
    int backOpinionType = displayConfig.getBackOpinionType();
    Map<Long, List<Comment>> commentMap = new HashMap<>();
    List<Comment> commentList = govdocCommentManager.getCommentList(ModuleType.edoc, summary.getId());
    if (Strings.isNotEmpty(commentList))
      commentMap = (Map<Long, List<Comment>>)commentList.stream().filter(item -> (backOpinionType != 1 || !"common.toolbar.stepBack.label".equals(item.getExtAtt3()))).collect(Collectors.groupingBy(Comment::getAffairId)); 
    boolean showZcdb = !FormOpinionConfig.checkBoolean(displayConfig.getZcdbOptionType());
    FormBean form = formApi4Cap3.getForm(summary.getFormAppid().longValue());
    Map<String, String> fieldNameMapElement = (Map<String, String>)form.getAllFieldBeans().stream().filter(fieldBean -> Strings.isNotBlank(fieldBean.getMappingField())).collect(Collectors.toMap(FormFieldBean::getName, FormFieldBean::getMappingField, (a, b) -> b));
    List<List<String>> rows = new ArrayList<>();
    List<EdocOpinion> senderOpinions = new ArrayList<>();
    for (Map.Entry<String, EdocOpinionModel> entry : filedNameMapOpinions.entrySet()) {
      String fieldName = entry.getKey();
      EdocOpinionModel model = entry.getValue();
      List<EdocOpinion> edocOpinionList = model.getOpinions();
      List<String> columns = new ArrayList<>();
      columns.add(fieldNameMapElement.get(fieldName));
      for (EdocOpinion opinion : edocOpinionList) {
        if (Strings.equals(Integer.valueOf(EdocOpinion.OpinionType.provisionalOpinoin.ordinal()), opinion.getOpinionType()) && !showZcdb)
          continue; 
        if (Strings.equals(Integer.valueOf(EdocOpinion.OpinionType.draftOpinion.ordinal()), opinion.getOpinionType()))
          continue; 
        V3xOrgMember member = null;
        try {
          member = orgManager.getMemberById(Long.valueOf(opinion.getCreateUserId()));
          if (member.getIsAdmin().booleanValue())
            continue; 
        } catch (BusinessException e) {
          LOGGER.error("", (Throwable)e);
        } 
        Comment comment = getComment(commentMap, opinion);
        if (comment == null) {
          LOGGER.error("文单区意见未找到对应的意见区意见，opinion.id=" + opinion.getId() + ", affairId=" + opinion.getAffairId());
          continue;
        } 
        if (Objects.nonNull(comment.getCreateDate()))
          opinion.setCreateTime(new Timestamp(comment.getCreateDate().getTime())); 
        String attitude = getAttitude(displayConfig, opinion, comment);
        if (Strings.isNotBlank(attitude) && !Strings.equals("report", opinion.getPolicy())) {
          String attitudeStr = "【" + attitude + "】";
          columns.add(attitudeStr);
        } 
        String content = opinion.getContent();
        if (!FormOpinionConfig.checkBoolean(displayConfig.getComment()))
          content = ""; 
        columns.add(content);
        boolean newLine = displayConfig.isInscriberNewLine();
        if (newLine) {
          columns.add("\r\n");
        } else if (Strings.isNotBlank(content)) {
          if (displayConfig.isShowDept() || displayConfig.isShowUnit())
            columns.add("  "); 
        } 
        boolean isDisplay = true;
        if (displayConfig.isHideInscriber())
          try {
            CtpAffair affair = affairManager.get(Long.valueOf(opinion.getAffairId()));
            if (affair != null && affair.getSubState().intValue() == SubStateEnum.col_done_stepStop.key())
              isDisplay = false; 
          } catch (BusinessException e) {
            LOGGER.error("获取affair错误", (Throwable)e);
          }  
        boolean hasHandWriteSignature = (affairIdMapHandWriteSign != null && affairIdMapHandWriteSign.containsKey(Long.valueOf(opinion.getAffairId())));
        String userName = getOpinionUserNameForM3(member, displayConfig, opinion, hasHandWriteSignature, edocOpinionSigns, opinion.getProxyName());
        if (displayConfig.isShowUnit() && (!displayConfig.isHideInscriber() || !hasHandWriteSignature) && isDisplay)
          if (newLine) {
            columns.add(opinion.getAccountName());
          } else {
            columns.add(" ");
            columns.add(opinion.getAccountName());
          }  
        if (displayConfig.isShowDept() && (!displayConfig.isHideInscriber() || !hasHandWriteSignature) && isDisplay)
          if (newLine && !displayConfig.isShowUnit()) {
            columns.add(opinion.getDepartmentName());
          } else {
            columns.add(" ");
            columns.add(opinion.getDepartmentName());
          }  
        boolean dateNewLine = FormOpinionConfig.checkBoolean(displayConfig.getDateNewLine());
        if (dateNewLine)
          columns.add(" "); 
        if (displayConfig.isShowName() && (!displayConfig.isHideInscriber() || !hasHandWriteSignature) && isDisplay) {
          columns.add(" ");
          columns.add(userName);
        } 
        String dateStr = getDateStr(displayConfig, opinion);
        if (Strings.isNotBlank(dateStr))
          if (dateNewLine) {
            columns.add("\r\n");
            columns.add(dateStr);
          } else {
            columns.add(" ");
            columns.add(dateStr);
          }  
        columns.add("\r\n");
        List<Attachment> tempAtts = null;
        if (null != opinion.getPolicy() && opinion.getPolicy().equals("feedback")) {
          Long subOpinionId = opinion.getSubOpinionId();
          if (subOpinionId != null)
            tempAtts = GovdocHelper.getOpinionAttachmentsNotRelationDoc(opinion.getSubEdocId().longValue(), subOpinionId.longValue()); 
        } else {
          tempAtts = opinion.getOpinionAttachments();
        } 
        if (tempAtts != null && displayConfig.isShowAtt()) {
          StringBuilder fileName = new StringBuilder();
          for (Attachment att : tempAtts) {
            columns.add("\r\n");
            fileName.setLength(0);
            fileName.append(att.getFilename());
            if (att.getSize().longValue() > 0L && att.getType().intValue() == 0)
              fileName.append("(").append(Strings.formatFileSize(att.getSize().longValue(), true)).append(")"); 
            columns.add(fileName.toString());
            columns.add(" ");
          } 
          columns.add(" ");
        } 
        columns.add("\n");
        if (hasHandWriteSignature) {
          V3xHtmDocumentSignature handWrite = affairIdMapHandWriteSign.get(Long.valueOf(opinion.getAffairId()));
          if (handWrite != null)
            columns.add("method=writeGIF&RECORDID=" + handWrite.getSummaryId() + "&FIELDNAME=" + handWrite.getFieldName() + "&isNewImg=true&affairId=" + handWrite.getAffairId()); 
        } 
        if (Strings.equals("senderOpinion", fieldName))
          senderOpinions.add(opinion); 
        rows.add(columns);
      } 
    } 
    List<Object> result = new ArrayList();
    result.add(rows);
    result.add(senderOpinions);
    return result;
  }
  
  private static String getDateStr(FormOpinionConfig displayConfig, EdocOpinion opinion) {
    String dateStr = "";
    if (EdocOpinionDisplayEnum.OpinionDateFormatSetEnum.DATETIME.getValue().equals(displayConfig.getShowDateType())) {
      if (EdocOpinionDisplayEnum.OpinionDateModelSetEnum.FULL.getValue().equals(displayConfig.getShowDateModel())) {
        Date current = opinion.getCreateTime();
        dateStr = Datetimes.format(current, ResourceUtil.getString("govdoc.date.format"));
      } else {
        dateStr = Datetimes.formatDatetimeWithoutSecond(opinion.getCreateTime());
      } 
    } else if (EdocOpinionDisplayEnum.OpinionDateFormatSetEnum.DATE.getValue().equals(displayConfig.getShowDateType())) {
      if (EdocOpinionDisplayEnum.OpinionDateModelSetEnum.FULL.getValue().equals(displayConfig.getShowDateModel())) {
        Date current = opinion.getCreateTime();
        dateStr = Datetimes.format(current, ResourceUtil.getString("govdoc.date.format1"));
      } else {
        dateStr = Datetimes.formatDate(opinion.getCreateTime());
      } 
    } else if (EdocOpinionDisplayEnum.OpinionDateFormatSetEnum.TIME.getValue().equals(displayConfig.getShowDateType())) {
      if (EdocOpinionDisplayEnum.OpinionDateModelSetEnum.FULL.getValue().equals(displayConfig.getShowDateModel())) {
        Date current = opinion.getCreateTime();
        dateStr = Datetimes.format(current, ResourceUtil.getString("govdoc.date.format3"));
      } else {
        dateStr = Datetimes.format(opinion.getCreateTime(), " HH:mm");
      } 
    } 
    return dateStr;
  }
  
  private static String getAttitude(FormOpinionConfig displayConfig, EdocOpinion opinion, Comment comment) {
    String tempAttitude = "";
    if (opinion.getAttribute() == 1) {
      tempAttitude = "haveRead";
    } else if (opinion.getAttribute() == 2) {
      tempAttitude = "agree";
    } else if (opinion.getAttribute() == 3) {
      tempAttitude = "disagree";
    } 
    String attitude = "";
    if (tempAttitude.equals((comment.getExtAtt4() == null) ? "" : comment.getExtAtt4()))
      attitude = comment.getExtAtt1I18n(); 
    if (Strings.isNotBlank(comment.getExtAtt1()))
      attitude = comment.getExtAtt1I18n(); 
    if (!FormOpinionConfig.checkBoolean(displayConfig.getAttitude()))
      attitude = ""; 
    return attitude;
  }
  
  private static Comment getComment(Map<Long, List<Comment>> commentMap, EdocOpinion opinion) {
    Comment comment = null;
    List<Comment> comments = commentMap.get(Long.valueOf(opinion.getAffairId()));
    if (Strings.isNotEmpty(comments))
      if (comments.size() == 1) {
        comment = comments.get(0);
      } else {
        for (Comment tempComment : comments) {
          if (tempComment.getCreateDate().equals(opinion.getCreateTime())) {
            comment = tempComment;
            break;
          } 
        } 
        if (comment == null) {
          Date beforeTwoSecond = Datetimes.addSecond(opinion.getCreateTime(), -3);
          Date afterTwoSecond = Datetimes.addSecond(opinion.getCreateTime(), 3);
          for (Comment tempComment : comments) {
            if (Datetimes.between(tempComment.getCreateDate(), beforeTwoSecond, afterTwoSecond, false)) {
              comment = tempComment;
              break;
            } 
          } 
        } 
        if (comment == null)
          comment = comments.get(0); 
      }  
    return comment;
  }
  
  private static FormOpinionConfig getFormOpinionConfig(EdocSummary summary, FormOptionExtendManager formOptionExtendManager) {
    FormOptionExtend govdocFormExtend = formOptionExtendManager.findByFormId(summary.getFormAppid().longValue());
    FormOpinionConfig displayConfig = null;
    if (null != govdocFormExtend) {
      displayConfig = (FormOpinionConfig)JSONUtil.parseJSONString(govdocFormExtend.getOptionFormatSet(), FormOpinionConfig.class);
      if (!govdocFormExtend.getOptionFormatSet().contains("showAtt"))
        displayConfig.setShowAtt(true); 
    } 
    if (displayConfig == null)
      displayConfig = new FormOpinionConfig(); 
    return displayConfig;
  }
}
